﻿Type=Class
Version=2.71
@EndOfDesignText@
'Class module
Sub Class_Globals
	Dim MenuItems As Map
	Dim mActivity As Activity
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Activity As Activity)
	mActivity = Activity
	MenuItems.Initialize
End Sub

Public Sub AddMenuItem(Title As String, EventName As String)
	MenuItems.Put(Title,EventName)	
End Sub

Public Sub AddMenuItemAt(Title As String, EventName As String, Index As Int) As Boolean
	If Index > MenuItems.Size-1 Then Return False

	Dim newMap As Map
	newMap.Initialize
	
	Dim n As Int
	
	For n = 0 To MenuItems.Size-1
		If n = Index Then newMap.Put(Title, EventName)
		newMap.Put(MenuItems.GetKeyAt(n), MenuItems.GetValueAt(n))		
	Next		

	MenuItems.Clear
	MenuItems = newMap
	
	Return True
End Sub

Public Sub UpdateMenuItem(OldTitle As String, NewTitle As String)
	Dim newMap As Map
	newMap.Initialize
	
	Dim n As Int
	
	For n = 0 To MenuItems.Size-1
		If MenuItems.GetKeyAt(n) = OldTitle Then
			newMap.Put(NewTitle, MenuItems.GetValueAt(n))
		Else
			newMap.Put(MenuItems.GetKeyAt(n), MenuItems.GetValueAt(n))
		End If
	Next		

	MenuItems.Clear
	MenuItems = newMap
End Sub

Public Sub DeleteMenuItem(Title As String)
	MenuItems.Remove(Title)	
End Sub

Public Sub RefreshMenu
	Dim Obj1 As Reflector
	Obj1.Target = Obj1.GetActivity
	
	Obj1.SetField2("menuItems", Null)	

	Dim n As Int
	
	For n = 0 To MenuItems.Size-1
		mActivity.AddMenuItem(MenuItems.GetKeyAt(n), MenuItems.GetValueAt(n))
	Next	
	
	Obj1.RunMethod("invalidateOptionsMenu")
End Sub